# Wellbore DMS demo in Jupyter Notebook

## Launch Jupyter Notebook

You can launch Jupyter Notebook either in console or in Docker.

### In console

**Prerequisite**: Install Python >= 3.7.

1. Enter the `app` directory.
2. [Optional] Create and activate virtual environment:
    ```
    # macOS/Linux
    python3 -m venv venv
    source venv/bin/activate
    ```
    ```
    # Windows
    python3 -m venv venv
    .\venv\Scripts\activate
    ```
  
3. Install Python dependencies:
    ```
    pip install -r requirements.txt
    ```
4. Run Jupyter Notebook:
    ```
    jupyter lab --notebook-dir=labs
    ```
    The lab will open in your default browser. 
5. Open `wellbore_dms_v3.ipynb` and start [running the lab](#jupyter-notebook-document).

#### In Docker

**Prerequisite**: on Mac or Windows install [Docker Desktop](https://www.docker.com/products/docker-desktop); on Linux install [Docker Engine](https://docs.docker.com/engine/install/).

1. Enter `app` directory.
2. Open terminal and start Docker build:

  ```
  docker build -t wellbore_dms_example .
  ```
3. Run Docker:
  
  ```
  docker run -p 8888:8888 wellbore_dms_example    
  ```
4. Finally, copy the last provided URL and open it in your browser:

<details>
  <summary>Click to view image</summary>

![Alt text](images/jupyter-console.png)
</details>

5. Proceed to Jupyter Notebook.
  
## Jupyter Notebook document

The Jupyter Notebook is an open source web application that you can use to create and share documents that contain live code, equations, visualizations, and text.

A Jupyter Notebook document (IPYNB file) contains the inputs and outputs of a interactive session as well as explanatory text. In this way, notebook files can serve as a complete computational record of a session, interleaving executable code with explanatory text, and rich representations of resulting objects.

A multiline input field is called a _cell_.

When a code cell is executed, the result is displayed in the notebook as the cell’s output. To execute a code cell:

1. Select a cell.
2. Run the code by pressing Shift+Enter, or clicking the Play button on the toolbar.

In `*.ipynb` files, execute code cells in a successive order. Otherwise, you may receive errors.

The number in square brackets indicates the sequence number of the most recent execution of the cell.
